Bug 10303 - glFogCoordPointer broken in DRI Radeon R300 driver
glFogCoordPointer broken in DRI Radeon R300 driver
Status: RESOLVED FIXED
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/r300
unspecified
x86 (IA32) Linux (All)
: medium normal
Assigned To: Default DRI bug account
Elmar Krieger
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-03-15 02:00 UTC by Elmar Krieger
Modified: 2009-03-19 05:09 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Elmar Krieger 2007-03-15 02:00:47 UTC
Hi!

This bug report is about the Mesa DRI R300 20060815 / Mesa 6.5.1 OpenGL driver shipped with Fedora Core 6.

The bug does *not* occur with driver DRI R200 and all other graphics cards / operating systems I tried:

Having determined the address of the OpenGL extension function 'glFogCoordPointer',  calls to this function don't have any effect, only display this error message in the console:



Try R300_SPAN_DISABLE_LOCKING env var if this hangs.
Mesa 6.5.1 implementation error: User called no-op dispatch function (an unsuppo
rted extension function?)
Please report at bugzilla.freedesktop.org
*********************************WARN_ONCE*********************************
File r300_vertexprog.c function t_dst_index line 184
Unknown output 3
***************************************************************************
Mesa 6.5.1 implementation error: User called no-op dispatch function (an unsuppo
rted extension function?)
Please report at bugzilla.freedesktop.org
Comment 1 Keith Whitwell 2007-03-15 02:14:09 UTC
Clarifying that this isn't a driver developed by Tungsten - the credit lies with the individual open source developers of the R300 project.
Comment 2 Roland Scheidegger 2007-03-15 03:26:35 UTC
the GL_VENDOR string which was copied from the radeon driver should probably be changed. Whoever wrote most of the code should pick a more appropriate one.
The no-op dispatch function error though likely means the driver does not implement GL_EXT_fogcoord at all, and if consequently it doesn't show up in the extension string it's not really a bug, just missing functionality.
Comment 3 Oliver McFadden 2007-03-15 03:37:39 UTC
There is a TODO comment in r300_fragprog.c about fog coord inputs, so it's
probably not done yet...

I think it was Vladimir Dergachev who did a lot of the initial work, at least
from looking at the R300 Sourceforge site, but I expect that a lot of people
made significant contributions, so maybe the vendor string should be "Vladimir
Dergachev et al" or similar.
Comment 4 Nicolai Hähnle 2007-03-16 19:41:10 UTC
> I think it was Vladimir Dergachev who did a lot of the initial work, at least
> from looking at the R300 Sourceforge site, but I expect that a lot of people
> made significant contributions, so maybe the vendor string should be "Vladimir
> Dergachev et al" or similar.

It's correct that Vladimir wrote the original reverse engineering tools. Virtually all of the reverse engineering that was actually necessary to start the driver was done by me, however (some time in late 2004, I think), which is when I also started the driver. I discontinued my work on the driver because I ran into hard lockups that I just didn't understand. It's cool to see that other people continued the work to a point where I can use the driver today.

I could claim that the driver is "mine" and it should be "Nicolai Hähnle et al", but that would be an insult to all the people who kept development going when I couldn't continue.

Anything involving attribution in such a prominent place is just bound to cause hard feelings. I'd remove the name completely, but then people might confuse the driver with ATI's binary driver. Therefore, I suggest we replace it with "The DRI project", because that really describes it best.

One can always put a list of authors where it really matters: in the source.
Comment 5 Oliver McFadden 2007-03-16 20:09:35 UTC
I agree with that. If there are no objections I can change the vendor string for R300.  I think that R300 does still use some Tungsten Graphics code, but it should be acceptable to change the vendor string because the code has appropriate copyright notices.  I will be away for some of the weekend, so if there are no objections by the time I'm back I'll commit this change. 
Comment 6 Oliver McFadden 2007-03-17 05:32:11 UTC
Dave Airlie already committed this. Commit 6a9b0cd0b43ba01b24871ec1fa155e192ddeaa56. 
Comment 7 Maciej Cencora 2009-03-19 05:09:19 UTC
Support for EXT_fog_coord in r300 has been commited to mesa master branch and
should be part of upcoming 7.5 release.
Please reopen if the bug still exists.